//+------------------------------------------------------------------+
//|                                            Shema_TD_BLS_21_1.mq4 |  
//|                                 Copyright  2009, Leonid Belskiy |  
//|                                         leonid.belskiy@gmail.com |   
//+------------------------------------------------------------------+  
#property copyright "Copyright  2009, Leonid Belskiy"
#property link      "leonid.belskiy@gmail.com"
//----
#property indicator_chart_window                                     //      ( )
//----
#include <log_BLS_20.mq4>                                            //    
//             ****    (     )****
extern int    StepBack=0;
//            --- // ---
//             ****   ( )****
int    StepBack=0;
//            --- // ---
//             ****   ( )****
int    TimeStart=0;                                                  //   
//            --- // ---
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
   {
	log_open( "log_BLS_20" );                                        //                                             
//            --- // ---
    return(0);
   }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {
    TimeEnd=TimeCurrent();                                           //    
//            --- // ---
	log_close();
    Comment(" ");
    ObjectsDeleteAll();                                              //      
    return(0);
   }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
//            --- // ---
    if((nTime!=Time[0])||(CurPeriod!=Period()))                                          //  -  ... 
        {  
//=================================================
//********     ********
//=================================================
//            --- // ---
         for(i=2+StepBack,D=2,NP=0; (NP<D)&&(i<Bars); i++)                               //      2-   
             {                                                                           //Begin
              if (High[i]!= High[i+1])                                                   //     
                  {
//            --- // ---
                  }
             }                                                                           //End;
//=================================================
//**********     ***********
//=================================================
//            --- // ---
         for(i=2+StepBack,D=2,NP=0; (NP<D)&&(i<Bars); i++)                               //      2-    
             {                                                                           //Begin
              if (Low[i]!= Low[i+1])                                                     //     
                  {
//            --- // ---
                  }
             }                                                                           //End;
//=================================================
//****         TD-                  ****
//=================================================
         buff_str="TD_Up";                                                               //     TD  Up
         if(ObjectFind(buff_str)==-1)                                                    //     "TD_Up"  , :
             {
              ObjectCreate(buff_str, OBJ_TREND, 0, UpBT[1], UpP[1], UpBT[0], UpP[0]);    //   OBJ_TREND-    
              ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                           //    (OBJPROP_STYLE) , 
              ObjectSet(buff_str, OBJPROP_COLOR, UpLineColor);                           //    (OBJPROP_COLOR) , 
              ObjectSet(buff_str, OBJPROP_WIDTH, UpLnWidth);                             //    (OBJPROP_WIDTH)  , 
             }
         else                                                                            //     "TD_Up" , :
             {
              ObjectMove(buff_str, 1, UpBT[0], UpP[0]);                                  //   .     
              ObjectMove(buff_str, 0, UpBT[1], UpP[1]);                                  //      0.
             }
         buff_str="TD_Dn";                                                               //     TD  Dn                                                                  // TD- Down
//            --- // ---
         CurPeriod=Period();                                                             //      
         nTime=Time[0];                                                                  //       
        }
//=================================================
//****            ****
//=================================================
    for(i=0;i<4;i++)                                                                     //     4-   2- 
    Target[i]=0;                                                                         //     i  
//-------------------------------------------------   
    Fun_New_Bar();

//-------------------------------------------------    
    i=0;
    if((Close[i]>UpP[0]+UpV*(UpB[0]-i)+Puncture*Point) && (High[i+1]<=UpP[0]+UpV*(UpB[0]-(i+1)))) //     TD_Up ,      TD 
        {
         iB_Up=i;                                                                   //    (  )  D_Up
         iP=UpP[0]+UpV*(UpB[0]-i);                                                  //    (iP)   TD_Up  
         iP_Up=iP;                                                                  //    (iP)   TD_Up 
//                                                 ----------     
         S1=Lowest(NULL,0,MODE_LOW,UpB[1]-(i+1),i+1);
         S2=Lowest(NULL,0,MODE_CLOSE,UpB[1]-(i+1),i+1);
//                                                 ----------  
         PP1=iP+((UpP[1]+UpV*(UpB[1]-S1))-Low[S1]);                                 //     1 (LOW ).
         PP2=iP+((UpP[1]+UpV*(UpB[1]-S2))-Low[S2]);                                 //     2 (LOW   CLOSE)
         PP3=iP+((UpP[1]+UpV*(UpB[1]-S1))-Close[S1]);                               //     3 (CLOSE   LOW)
         PP4=(PP1+PP2+PP3)/3;
         UpPP1=(UpP[1]+UpV*(UpB[1]-S1))-Low[S1];                                    // (15)   1
         UpPP2=(UpP[1]+UpV*(UpB[1]-S2))-Low[S2];                                    // (15)   2
         UpPP3=(UpP[1]+UpV*(UpB[1]-S1))-Close[S1];                                  // (15)   3
         UpPP4=(UpPP1+UpPP2+UpPP3)/3;                                               // (15)   4
//                                                 ----------   
         if(NoQw
         || (Qw1 && Close[i+2]>Close[i+1])
         || (Qw2 && Open[i]> iP)
         || (Qw3 && (Close[i+1]+(Close[i+1]-MathMin(Low[i+1],Close[i+2])))<iP)
         || (Qw1Qw2 && Close[i+2]>Close[i+1]&& Open[i]> iP)
         || (Qw2Qw3 && Open[i]> iP && (Close[i+1]+(Close[i+1]-MathMin(Low[i+1],Close[i+2])))<iP)
         || (Qw1Qw3 && Close[i+2]>Close[i+1] && (Close[i+1]+(Close[i+1]-MathMin(Low[i+1],Close[i+2])))<iP))                           
             {
//                                                 ----------    
              Target[0]=PP1;                                                        //      1 ()
              Target[1]=PP2;                                                        //      2 ( )
              Target[2]=PP3;                                                        //      3 ( )
              Target[3]=(PP1+PP2+PP3)/3;                                            //      ()
//                                                 ----------        ()
              buff_str="Break_Sig_Up";                                              //     ()
              if(ObjectFind(buff_str)==-1) 
                  {
                   ObjectCreate(buff_str, OBJ_ARROW,0, Time[iB_Up], iP-3*Point );   //  , OBJ_ARROW- ()
                   ObjectSet(buff_str, OBJPROP_ARROWCODE, 164);                     //     OBJ_ARROW
                   ObjectSet(buff_str, OBJPROP_COLOR, Red);                         //   OBJPROP_COLOR-, 
                  }
              else 
                  {
                   ObjectMove(buff_str, 0, Time[iB_Up], iP-3*Point );
                  }
//******************************************************************************************************************************
//*************************************************----------       ()
              if(Flag_Up==true)
                  {
                   buff_str="Line_Up"+bay;                                                 
                   if(ObjectFind(buff_str)==-1)// && Flag_Up==true)
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, UpBT[1], UpP[1], Time[iB_Up], iP);    //   OBJ_TREND-  
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 //    (OBJPROP_STYLE) ,
                        ObjectSet(buff_str, OBJPROP_COLOR, UpLineColor);                 //    (OBJPROP_COLOR) , 
                        ObjectSet(buff_str, OBJPROP_WIDTH, UpLnWidth);                   //    (OBJPROP_WIDTH)  ,
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         //    (OBJPROP_RAY)   
                       }
//                                                       ---      
                   buff_str="LineP1_Up"+bay;                                                 
                   if(ObjectFind(buff_str)==-1 && P1)// && Flag_Up==true)                                    // P1 -      PP1
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, Time[iB_Up], iP, Time[iB_Up]-1, PP1);
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
                        ObjectSet(buff_str, OBJPROP_COLOR, Target_Color[0]);             
                        ObjectSet(buff_str, OBJPROP_WIDTH, UpLnWidth);                   
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         
                       }
                   buff_str="LineP2_Up"+bay;                                                 
                   if(ObjectFind(buff_str)==-1 && P2)// && Flag_Up==true) 
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, Time[iB_Up], iP, Time[iB_Up]-1, PP2);
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
                        ObjectSet(buff_str, OBJPROP_COLOR, Target_Color[1]);             
                        ObjectSet(buff_str, OBJPROP_WIDTH, UpLnWidth);                   
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         
                        }
                   buff_str="LineP3_Up"+bay;                                                 
                   if(ObjectFind(buff_str)==-1 && P3)// && Flag_Up==true) 
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, Time[iB_Up], iP, Time[iB_Up]-1, PP3);
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
                        ObjectSet(buff_str, OBJPROP_COLOR, Target_Color[2]);             
                        ObjectSet(buff_str, OBJPROP_WIDTH, UpLnWidth);                   
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         
                       }
                   buff_str="LineP4_Up"+bay;                                                 
                   if(ObjectFind(buff_str)==-1 && P4)// && Flag_Up==true) 
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, Time[iB_Up], iP, Time[iB_Up]-1, PP4);
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
                        ObjectSet(buff_str, OBJPROP_COLOR, Target_Color[3]);             
                        ObjectSet(buff_str, OBJPROP_WIDTH, UpLnWidth);                   
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         
                       }
//================================================
//****      (19)         ****
//================================================
//                   if(MiB_Up[1]==0 && Flag_Up_Start==false && Flag_Dn_Start==false)// (19-4)         

                   if(MiB_Up[1]==0 && Flag_Up_CD_Start==false && Flag_Up_Start==false && Flag_Dn_Start==false)
                       {
                        MiB_Up[1]=i;                                 // (19)     Up  MiB_Up[1]-, MiB_Up[0]-
                        MiP_Up[1]=Close[i];                          // (19)    Up  MiP_Up[1]-, MiP_Up[0]-
                        MiBT_Up[1]=TimeCurrent();          // (19-4)      
//                        Flag_Up_Start=true;                // (19-4)                                     
                        Flag_Up_CD_Start=true;                       // (19)       -                                    
                        Flag_Up_CD_End=false;                        // (19)    
                        Flag_Dn_Start=true; // (19-7)    Dn 


      AG_Message(Message, ":    Buy.");//(.62)
      MN = AG_Magic_Number();          //  MagicNumber ()
                                       //   Buy:
      OrderSend( Symbol(), OP_BUY, Lot, Ask, 2, Bid-SL*Point, Bid+TP*Point, Comm, MN); 



//                        CritTrade=10;
//                        AG_Trade_Criterion_BLS();                   //     BLS
                       }                                   

                   bay++;                                            // (15)      
                   Flag_Up=false;                                    //   -      
                  }
             }
        }
//
//
//
//=================================================
//****      (19-1)        ****
//=================================================
    i=0;
    if(Flag_Up_CD_Start==true && Flag_Up_CD_End==false)              // (19)        -                                   
//    if(Flag_Up_Start==true)                                // (19-4)                                     
        {                                                            // (19)   ,   [0]   
         MiB_Up[0]=i;                                                // (19)     Up  MiB_Up[1]-, MiB_Up[0]-
         MiP_Up[0]=Close[i];                                         // (19)    Up  MiP_Up[1]-, MiP_Up[0]-
         MiBT_Up[0]=TimeCurrent();                         // (19-4)      

//-------(19-4)   ( )

         iBT_Up=MiBT_Up[0]-MiBT_Up[1];                     // (19-4)     Up  ( )    
         days_Up=MathFloor(MathFloor(MathFloor(iBT_Up/60)/60)/24);                                           // (19-4)     Up  ( )
         hours_Up=MathFloor(MathFloor(iBT_Up/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Up/60)/60)/24)*24;    // (19-4)     Up  ( )
         minutes_Up=MathFloor(iBT_Up/60)-MathFloor(MathFloor(iBT_Up/60)/60)*60;                              // (19-4)     Up  ( )
         seconds_Up=iBT_Up-MathFloor(iBT_Up/60)*60;                                                          // (19-4)     Up  ( )

//-------
         Level_TrSL=iP_Up-TrStopLoss*Point;                          // (19)     

//-------(19-5)   ( )

//         spread = Ask - Bid                                // (19-5)    ( )
         Result=((MiP_Up[0]-MiP_Up[1])- spread*Point)*10000;       // (19-8)    c  ( )
         if(Result>0)
             {
              Result_P=Result;                             // (19-5)    c  ( ) P-Profit ()
              Result_L=0;
             }
         else
             {
              Result_L=Result;                             // (19-5)    c  ( ) L-Loss   ()
              Result_P=0;
             }

//-------(19-5)   Up
         
         buff_str="Profit_Up" + bay_CD;
         if(ObjectFind(buff_str)==-1) 
             {
              ObjectCreate(buff_str, OBJ_TREND, 0, MiBT_Up[1], MiP_Up[1], MiBT_Up[0], MiP_Up[0]);
              ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
              ObjectSet(buff_str, OBJPROP_COLOR, Violet);            // Violet         
              ObjectSet(buff_str, OBJPROP_WIDTH, 2);                   
              ObjectSet(buff_str, OBJPROP_RAY, false);                         
             }
         if(Close[i]>MiP_Up[1] + spread*Point )                      // (19)        
             {
              ObjectMove(buff_str, 1, MiBT_Up[0], MiP_Up[0]);        // (19)   . 
              ObjectMove(buff_str, 0, MiBT_Up[1], MiP_Up[1]);        // (19)   .Deal 
              ObjectSet(buff_str, OBJPROP_COLOR, Blue);            // (19)     Violet Red        
              WindowRedraw();
             }
         else
             {
              ObjectMove(buff_str, 1, MiBT_Up[0], MiP_Up[0]);        // (19)   . 
              ObjectMove(buff_str, 0, MiBT_Up[1], MiP_Up[1]);        // (19)   .Deal 
              ObjectSet(buff_str, OBJPROP_COLOR, Red);             // (19)     Brown Blue        
              ObjectSet(buff_str, OBJPROP_WIDTH, 2);
              WindowRedraw();
             }

//-------(19-5)    Up
//         
         if(CD_TrSL && Close[i]<iP_Up-TrStopLoss*Point)              // (19) (TrStopLoss==TrSL)    TrStopLoss        
             {

            if (NormalizeDouble(Order[1][6],0) == 0.0)            //    Buy
               {                                      
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);  //  
               _Ord_Lots = NormalizeDouble(Order[1][5],2); //  
               OrderClose(_Ord_Ticket, _Ord_Lots, Bid, 2);        //   Buy
               }

//              CritTrade=11;                               // (20-1)   BAY 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS

//-------------------------------(19-5)    Up  ( )
              iBT_Up_Oll=iBT_Up_Oll+iBT_Up;                                                                                   // (19-5)        Up  ( )    
              days_Up_Oll=MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24);                                               // (19-4)      Up  ( )
              hours_Up_Oll=MathFloor(MathFloor(iBT_Up_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24)*24;    // (19-4)     Up  ( )
              minutes_Up_Oll=MathFloor(iBT_Up_Oll/60)-MathFloor(MathFloor(iBT_Up_Oll/60)/60)*60;                              // (19-4)     Up  ( )
              seconds_Up_Oll=iBT_Up_Oll-MathFloor(iBT_Up_Oll/60)*60;                                                          // (19-4)    Up  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Up;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Up  ( )
              Balance_Up=Balance_Up + Result;                        // (19-5)  Up  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Up_P=Result_Up_P+Result;                             // (19-5)  Up  c   ( ) P-Profit ()
                   Result_Up_L=Result_Up_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   bayP_CD++;                              // (19-9)   Up 
                   Tr_Up_P++;                              // (19-9)       
                  }
              else
                  {
                   Result_Up_L=Result_Up_L+Result;                             // (19-5)  Up  c   ( ) L-Loss   ()
                   Result_Up_P=Result_Up_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   bayL_CD++;                              // (19-9)   Up 
                   Tr_Up_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                                // (19-9)   
              bay_CD++;                                              //   Up 
              Tr_Up++;                                               //   Tr Up 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Up[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[1], Digits )                                                 + ";" + //    

                   "Tr"                                                                             + ";" + //   (Tr) Up 
                   TimeToStr( MiBT_Up[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[0], Digits )                                                 + ";" + //   
                   
                   days_Up + ";" + hours_Up + ";" + minutes_Up + ";" + seconds_Up                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Up" + ";" + bay_CD + ";" + bayP_CD + ";" + bayL_CD                              + ";" + // (19-9)   Up , , 
                   days_Up_Oll + ";" + hours_Up_Oll + ";" + minutes_Up_Oll + ";" + seconds_Up_Oll   + ";" + // (19-5)     Up  
                   Balance_Up + ";" + Result_Up_P + ";" + Result_Up_L                               + ";" + // (19-9)    Up  ()
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Dn  ()
                   
                   Tr_Up + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + ""                  //   Tr Up 

                  ); */
//--------------------------------              
              Flag_Up_CD_End=true;                                   // (19)                                         
              Flag_Up_CD_Start=false;                                // (19)          
              Flag_Dn_Start=false;    // (19-7)    Dn 

             }
// 
         if(CD_CC && Close[i]<iP_Dn-PunctureCC*Point)      // (19)(Crossounter==)      ()
             {
            if (NormalizeDouble(Order[1][6],0) == 0.0)            //    Buy
               {                                      
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);  //  
               _Ord_Lots = NormalizeDouble(Order[1][5],2); //  
               OrderClose(_Ord_Ticket, _Ord_Lots, Bid, 2);        //   Buy
               }

//              CritTrade=11;                               // (20-1)   BAY 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Up  ( )
              iBT_Up_Oll=iBT_Up_Oll+iBT_Up;                                                                                   // (19-5)        Up  ( )    
              days_Up_Oll=MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24);                                               // (19-4)      Up  ( )
              hours_Up_Oll=MathFloor(MathFloor(iBT_Up_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24)*24;    // (19-4)     Up  ( )
              minutes_Up_Oll=MathFloor(iBT_Up_Oll/60)-MathFloor(MathFloor(iBT_Up_Oll/60)/60)*60;                              // (19-4)     Up  ( )
              seconds_Up_Oll=iBT_Up_Oll-MathFloor(iBT_Up_Oll/60)*60;                                                          // (19-4)    Up  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Up;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Up  ( )
              Balance_Up=Balance_Up + Result;                        // (19-5)  Up  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Up_P=Result_Up_P+Result;                             // (19-5)  Up  c   ( ) P-Profit ()
                   Result_Up_L=Result_Up_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   bayP_CD++;                              // (19-9)   Up 
                   CC_Up_P++;                              // (19-9)       
                  }
              else
                  {
                   Result_Up_L=Result_Up_L+Result;                             // (19-5)  Up  c   ( ) L-Loss   ()
                   Result_Up_P=Result_Up_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   bayL_CD++;                              // (19-9)   Up 
                   CC_Up_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                                // (19-9)   
              bay_CD++;                                              //   Up 
              CC_Up++;                                               //   CC_Up 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Up[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[1], Digits )                                                 + ";" + //    

                   "CC"                                                                             + ";" + //   (Tr) Up 
                   TimeToStr( MiBT_Up[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[0], Digits )                                                 + ";" + //   
                   
                   days_Up + ";" + hours_Up + ";" + minutes_Up + ";" + seconds_Up                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Up" + ";" + bay_CD + ";" + bayP_CD + ";" + bayL_CD                              + ";" + // (19-9)   Up , , 
                   days_Up_Oll + ";" + hours_Up_Oll + ";" + minutes_Up_Oll + ";" + seconds_Up_Oll   + ";" + // (19-5)     Up  
                   Balance_Up + ";" + Result_Up_P + ";" + Result_Up_L                               + ";" + // (19-9)    Up  ()
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Dn  ()
                   
                   "" + ";" + CC_Up + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + ""                  //   CC_Up 

                  ); */
//--------------------------------              
              Flag_Up_CD_End=true;                                   // (19)                                         
              Flag_Up_CD_Start=false;                                // (19)          
              Flag_Dn_Start=false;    // (19-7)    Dn 

             }

// 
         if(CD_PP1 && Close[i]>=PP1)                       // (19)       1
             {
            if (NormalizeDouble(Order[1][6],0) == 0.0)            //    Buy
               {                                      
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);  //  
               _Ord_Lots = NormalizeDouble(Order[1][5],2); //  
               OrderClose(_Ord_Ticket, _Ord_Lots, Bid, 2);        //   Buy
               }

//              CritTrade=11;                               // (20-1)   BAY 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Up  ( )
              iBT_Up_Oll=iBT_Up_Oll+iBT_Up;                                                                                   // (19-5)        Up  ( )    
              days_Up_Oll=MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24);                                               // (19-4)      Up  ( )
              hours_Up_Oll=MathFloor(MathFloor(iBT_Up_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24)*24;    // (19-4)     Up  ( )
              minutes_Up_Oll=MathFloor(iBT_Up_Oll/60)-MathFloor(MathFloor(iBT_Up_Oll/60)/60)*60;                              // (19-4)     Up  ( )
              seconds_Up_Oll=iBT_Up_Oll-MathFloor(iBT_Up_Oll/60)*60;                                                          // (19-4)    Up  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Up;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Up  ( )
              Balance_Up=Balance_Up + Result;                        // (19-5)  Up  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Up_P=Result_Up_P+Result;                             // (19-5)  Up  c   ( ) P-Profit ()
                   Result_Up_L=Result_Up_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   bayP_CD++;                              // (19-9)   Up 
                   P1_Up_P++;                              // (19-9)       
                  }
              else
                  {
                   Result_Up_L=Result_Up_L+Result;                             // (19-5)  Up  c   ( ) L-Loss   ()
                   Result_Up_P=Result_Up_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   bayL_CD++;                              // (19-9)   Up 
                   P1_Up_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                                // (19-9)   
              bay_CD++;                                              //   Up 
              P1_Up++;                                               //   P1_Up 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Up[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[1], Digits )                                                 + ";" + //    

                   "P1"                                                                             + ";" + //   (Tr) Up 
                   TimeToStr( MiBT_Up[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[0], Digits )                                                 + ";" + //   
                   
                   days_Up + ";" + hours_Up + ";" + minutes_Up + ";" + seconds_Up                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Up" + ";" + bay_CD + ";" + bayP_CD + ";" + bayL_CD                              + ";" + // (19-9)   Up , , 
                   days_Up_Oll + ";" + hours_Up_Oll + ";" + minutes_Up_Oll + ";" + seconds_Up_Oll   + ";" + // (19-5)     Up  
                   Balance_Up + ";" + Result_Up_P + ";" + Result_Up_L                               + ";" + // (19-9)    Up  ()
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Dn  ()
                   
                   "" + ";" + "" + ";" + P1_Up + ";" + "" + ";" + "" + ";" + "" + ";" + ""                  //   P1_Up 

                  ); */
//--------------------------------              
              Flag_Up_CD_End=true;                                   // (19)                                         
              Flag_Up_CD_Start=false;                                // (19)          
              Flag_Dn_Start=false;    // (19-7)    Dn 

             }

// 
         if(CD_PP2 && Close[i]>=PP2)                       // (19)       2
             {
            if (NormalizeDouble(Order[1][6],0) == 0.0)            //    Buy
               {                                      
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);  //  
               _Ord_Lots = NormalizeDouble(Order[1][5],2); //  
               OrderClose(_Ord_Ticket, _Ord_Lots, Bid, 2);        //   Buy
               }

//              CritTrade=11;                               // (20-1)   BAY 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Up  ( )
              iBT_Up_Oll=iBT_Up_Oll+iBT_Up;                                                                                   // (19-5)        Up  ( )    
              days_Up_Oll=MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24);                                               // (19-4)      Up  ( )
              hours_Up_Oll=MathFloor(MathFloor(iBT_Up_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24)*24;    // (19-4)     Up  ( )
              minutes_Up_Oll=MathFloor(iBT_Up_Oll/60)-MathFloor(MathFloor(iBT_Up_Oll/60)/60)*60;                              // (19-4)     Up  ( )
              seconds_Up_Oll=iBT_Up_Oll-MathFloor(iBT_Up_Oll/60)*60;                                                          // (19-4)    Up  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Up;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Up  ( )
              Balance_Up=Balance_Up + Result;                        // (19-5)  Up  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Up_P=Result_Up_P+Result;                             // (19-5)  Up  c   ( ) P-Profit ()
                   Result_Up_L=Result_Up_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   bayP_CD++;                              // (19-9)   Up 
                   P2_Up_P++;                              // (19-9)       
                  }
              else
                  {
                   Result_Up_L=Result_Up_L+Result;                             // (19-5)  Up  c   ( ) L-Loss   ()
                   Result_Up_P=Result_Up_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   bayL_CD++;                              // (19-9)   Up 
                   P2_Up_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                                // (19-9)   
              bay_CD++;                                              //   Up 
              P2_Up++;                                               //   P2_Up 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Up[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[1], Digits )                                                 + ";" + //    

                   "P2"                                                                             + ";" + //   (Tr) Up 
                   TimeToStr( MiBT_Up[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[0], Digits )                                                 + ";" + //   
                   
                   days_Up + ";" + hours_Up + ";" + minutes_Up + ";" + seconds_Up                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Up" + ";" + bay_CD + ";" + bayP_CD + ";" + bayL_CD                              + ";" + // (19-9)   Up , , 
                   days_Up_Oll + ";" + hours_Up_Oll + ";" + minutes_Up_Oll + ";" + seconds_Up_Oll   + ";" + // (19-5)     Up  
                   Balance_Up + ";" + Result_Up_P + ";" + Result_Up_L                               + ";" + // (19-9)    Up  ()
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Dn  ()
                   
                   "" + ";" + "" + ";" + "" + ";" + P2_Up + ";" + "" + ";" + "" + ";" + ""                  //   P2_Up 

                  ); */
//--------------------------------              
              Flag_Up_CD_End=true;                                   // (19)                                         
              Flag_Up_CD_Start=false;                                // (19)          
              Flag_Dn_Start=false;    // (19-7)    Dn 

             }

// 
         if(CD_PP3 && Close[i]>=PP3)                       // (19)       3
             {
            if (NormalizeDouble(Order[1][6],0) == 0.0)            //    Buy
               {                                      
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);  //  
               _Ord_Lots = NormalizeDouble(Order[1][5],2); //  
               OrderClose(_Ord_Ticket, _Ord_Lots, Bid, 2);        //   Buy
               }

//              CritTrade=11;                               // (20-1)   BAY 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Up  ( )
              iBT_Up_Oll=iBT_Up_Oll+iBT_Up;                                                                                   // (19-5)        Up  ( )    
              days_Up_Oll=MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24);                                               // (19-4)      Up  ( )
              hours_Up_Oll=MathFloor(MathFloor(iBT_Up_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24)*24;    // (19-4)     Up  ( )
              minutes_Up_Oll=MathFloor(iBT_Up_Oll/60)-MathFloor(MathFloor(iBT_Up_Oll/60)/60)*60;                              // (19-4)     Up  ( )
              seconds_Up_Oll=iBT_Up_Oll-MathFloor(iBT_Up_Oll/60)*60;                                                          // (19-4)    Up  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Up;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Up  ( )
              Balance_Up=Balance_Up + Result;                        // (19-5)  Up  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Up_P=Result_Up_P+Result;                             // (19-5)  Up  c   ( ) P-Profit ()
                   Result_Up_L=Result_Up_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   bayP_CD++;                              // (19-9)   Up 
                   P3_Up_P++;                              // (19-9)       
                  }
              else
                  {
                   Result_Up_L=Result_Up_L+Result;                             // (19-5)  Up  c   ( ) L-Loss   ()
                   Result_Up_P=Result_Up_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   bayL_CD++;                              // (19-9)   Up 
                   P3_Up_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                                // (19-9)   
              bay_CD++;                                              //   Up 
              P3_Up++;                                               //   P3_Up 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Up[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[1], Digits )                                                 + ";" + //    

                   "P3"                                                                             + ";" + //   (Tr) Up 
                   TimeToStr( MiBT_Up[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[0], Digits )                                                 + ";" + //   
                   
                   days_Up + ";" + hours_Up + ";" + minutes_Up + ";" + seconds_Up                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Up" + ";" + bay_CD + ";" + bayP_CD + ";" + bayL_CD                              + ";" + // (19-9)   Up , , 
                   days_Up_Oll + ";" + hours_Up_Oll + ";" + minutes_Up_Oll + ";" + seconds_Up_Oll   + ";" + // (19-5)     Up  
                   Balance_Up + ";" + Result_Up_P + ";" + Result_Up_L                               + ";" + // (19-9)    Up  ()
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Dn  ()
                   
                   "" + ";" + "" + ";" + "" + ";" + "" + ";" + P3_Up + ";" + "" + ";" + ""                  //   P3_Up 

                  ); */
//--------------------------------              
              Flag_Up_CD_End=true;                                   // (19)                                         
              Flag_Up_CD_Start=false;                                // (19)          
              Flag_Dn_Start=false;    // (19-7)    Dn 

             }

// 
         if(CD_PP4 && Close[i]>=PP4)                       // (19)       4
             {
            if (NormalizeDouble(Order[1][6],0) == 0.0)            //    Buy
               {                                      
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);  //  
               _Ord_Lots = NormalizeDouble(Order[1][5],2); //  
               OrderClose(_Ord_Ticket, _Ord_Lots, Bid, 2);        //   Buy
               }

//              CritTrade=11;                               // (20-1)   BAY 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Up  ( )
              iBT_Up_Oll=iBT_Up_Oll+iBT_Up;                                                                                   // (19-5)        Up  ( )    
              days_Up_Oll=MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24);                                               // (19-4)      Up  ( )
              hours_Up_Oll=MathFloor(MathFloor(iBT_Up_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24)*24;    // (19-4)     Up  ( )
              minutes_Up_Oll=MathFloor(iBT_Up_Oll/60)-MathFloor(MathFloor(iBT_Up_Oll/60)/60)*60;                              // (19-4)     Up  ( )
              seconds_Up_Oll=iBT_Up_Oll-MathFloor(iBT_Up_Oll/60)*60;                                                          // (19-4)    Up  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Up;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Up  ( )
              Balance_Up=Balance_Up + Result;                        // (19-5)  Up  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Up_P=Result_Up_P+Result;                             // (19-5)  Up  c   ( ) P-Profit ()
                   Result_Up_L=Result_Up_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   bayP_CD++;                              // (19-9)   Up 
                   P4_Up_P++;                              // (19-9)       
                  }
              else
                  {
                   Result_Up_L=Result_Up_L+Result;                             // (19-5)  Up  c   ( ) L-Loss   ()
                   Result_Up_P=Result_Up_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   bayL_CD++;                              // (19-9)   Up 
                   P4_Up_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                                // (19-9)   
              bay_CD++;                                              //   Up 
              P4_Up++;                                               //   P4_Up 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Up[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[1], Digits )                                                 + ";" + //    

                   "P4"                                                                             + ";" + //   (Tr) Up 
                   TimeToStr( MiBT_Up[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[0], Digits )                                                 + ";" + //   
                   
                   days_Up + ";" + hours_Up + ";" + minutes_Up + ";" + seconds_Up                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Up" + ";" + bay_CD + ";" + bayP_CD + ";" + bayL_CD                              + ";" + // (19-9)   Up , , 
                   days_Up_Oll + ";" + hours_Up_Oll + ";" + minutes_Up_Oll + ";" + seconds_Up_Oll   + ";" + // (19-5)     Up  
                   Balance_Up + ";" + Result_Up_P + ";" + Result_Up_L                               + ";" + // (19-9)    Up  ()
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Dn  ()
                   
                   "" + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + P4_Up + ";" + ""                  //   P4_Up 

                  ); */
//--------------------------------              
              Flag_Up_CD_End=true;                                   // (19)                                         
              Flag_Up_CD_Start=false;                                // (19)          
              Flag_Dn_Start=false;    // (19-7)    Dn 

             }
// 
         if(CD_OO && (Close[i]<DownP[0]+DownV*(DownB[0]-i)-Puncture*Point)   // (19) (OpenOpposite==OO)   
                  && (Low[i+1]>=DownP[0]+DownV*(DownB[0]-(i+1))))              
             {
            if (NormalizeDouble(Order[1][6],0) == 0.0)            //    Buy
               {                                      
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);  //  
               _Ord_Lots = NormalizeDouble(Order[1][5],2); //  
               OrderClose(_Ord_Ticket, _Ord_Lots, Bid, 2);        //   Buy
               }

//              CritTrade=11;                               // (20-1)   BAY 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Up  ( )
              iBT_Up_Oll=iBT_Up_Oll+iBT_Up;                                                                                   // (19-5)        Up  ( )    
              days_Up_Oll=MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24);                                               // (19-4)      Up  ( )
              hours_Up_Oll=MathFloor(MathFloor(iBT_Up_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Up_Oll/60)/60)/24)*24;    // (19-4)     Up  ( )
              minutes_Up_Oll=MathFloor(iBT_Up_Oll/60)-MathFloor(MathFloor(iBT_Up_Oll/60)/60)*60;                              // (19-4)     Up  ( )
              seconds_Up_Oll=iBT_Up_Oll-MathFloor(iBT_Up_Oll/60)*60;                                                          // (19-4)    Up  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Up;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Up  ( )
              Balance_Up=Balance_Up + Result;                        // (19-5)  Up  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Up_P=Result_Up_P+Result;                             // (19-5)  Up  c   ( ) P-Profit ()
                   Result_Up_L=Result_Up_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   bayP_CD++;                              // (19-9)   Up 
                   OO_Up_P++;                              // (19-9)       
                  }
              else
                  {
                   Result_Up_L=Result_Up_L+Result;                             // (19-5)  Up  c   ( ) L-Loss   ()
                   Result_Up_P=Result_Up_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   bayL_CD++;                              // (19-9)   Up 
                   OO_Up_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                                // (19-9)   
              bay_CD++;                                              //   Up 
              OO_Up++;                                               //   OO_Up 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Up[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[1], Digits )                                                 + ";" + //    

                   "OO"                                                                             + ";" + //   (Tr) Up 
                   TimeToStr( MiBT_Up[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Up[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Up[0], Digits )                                                 + ";" + //   
                   
                   days_Up + ";" + hours_Up + ";" + minutes_Up + ";" + seconds_Up                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Up" + ";" + bay_CD + ";" + bayP_CD + ";" + bayL_CD                              + ";" + // (19-9)   Up , , 
                   days_Up_Oll + ";" + hours_Up_Oll + ";" + minutes_Up_Oll + ";" + seconds_Up_Oll   + ";" + // (19-5)     Up  
                   Balance_Up + ";" + Result_Up_P + ";" + Result_Up_L                               + ";" + // (19-9)    Up  ()
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Dn  ()
                   
                   "" + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + OO_Up                  //   OO_Up 

                  ); */
//--------------------------------              
              Flag_Up_CD_End=true;                                   // (19)                                         
              Flag_Up_CD_Start=false;                                // (19)          
              Flag_Dn_Start=false;    // (19-7)    Dn 

             }

         WindowRedraw();         
        }
//******************************************************************************************************************************
//******************************************************************************************************************************

//------------------------------------------------    
    i=0;
    if((Close[i]<DownP[0]+DownV*(DownB[0]-i)-Puncture*Point) && (Low[i+1]>=DownP[0]+DownV*(DownB[0]-(i+1))))
        {
         iB_Dn=i;                                                                   //     TD 
         iP=DownP[0]+DownV*(DownB[0]-i);                                            //      TD 
         iP_Dn=iP;                                                                  //       TD 
//                                                -----------     
         S1=Highest(NULL,0,MODE_HIGH,DownB[1]-(i+1),i+1);                                 //     HIGH (MODE_HIGH-  )
         S2=Highest(NULL,0,MODE_CLOSE,DownB[1]-(i+1),i+1);                                //      CLOSE
//                                                -----------  
         PP1=iP-(High[S1]-(DownP[1]+DownV*(DownB[1]-S1)));                          //  1 (High )
         PP2=iP-(High[S2]-(DownP[1]+DownV*(DownB[1]-S2)));                          //  2 (High   CLOSE)
         PP3=iP-(Close[S1]-(DownP[1]+DownV*(DownB[1]-S1)));                         //  3 (CLOSE   High)
         PP4=(PP1+PP2+PP3)/3;
         DnPP1=High[S1]-(DownP[1]+DownV*(DownB[1]-S1));                             // (15)   1
         DnPP2=High[S2]-(DownP[1]+DownV*(DownB[1]-S2));                             // (15)   2
         DnPP3=Close[S1]-(DownP[1]+DownV*(DownB[1]-S1));                            // (15)   3
         DnPP4=(DnPP1+DnPP2+DnPP3)/3;                                               // (15)   4
//                                                 ----------   
         if(NoQw
         || (Qw1 && Close[i+2]<Close[i+1])                                          //       
         || (Qw2 && Open[i] < iP)                                                   //     TD 
         || (Qw3 && (Close[i+1]+(Close[i+1]-MathMax(High[i+1],Close[i+2])))>iP)     // 
         || (Qw1Qw2 && Close[i+2]<Close[i+1] && Open[i] < iP)                                                   // 
         || (Qw2Qw3 && Open[i] < iP && (Close[i+1]+(Close[i+1]-MathMax(High[i+1],Close[i+2])))>iP)
         || (Qw1Qw3 && Close[i+2]<Close[i+1] && (Close[i+1]+(Close[i+1]-MathMax(High[i+1],Close[i+2])))>iP))
             {
//                                                 ----------    
              Target[0]=PP1;                                                        //      1 ()
              Target[1]=PP2;                                                        //      2 ( )
              Target[2]=PP3;                                                        //      3 ( )
              Target[3]=(PP1+PP2+PP3)/3;                                            //      ()
//                                                 ----------        ()
              buff_str="Break_Sig_Dn";                                              //     ()
              if(ObjectFind(buff_str)==-1) 
                  {
                   ObjectCreate(buff_str, OBJ_ARROW,0, Time[iB_Dn], iP+3*Point );   //  , OBJ_ARROW- ()
                   ObjectSet(buff_str, OBJPROP_ARROWCODE, 164);                     //     OBJ_ARROW
                   ObjectSet(buff_str, OBJPROP_COLOR, Blue);                        //   OBJPROP_COLOR-, 
                  }
              else 
                  {
                   ObjectMove(buff_str, 0, Time[iB_Dn], iP+3*Point );
                  }
//*************************************************----------       ()
              if(Flag_Dn==true) 
                  {
                   buff_str="Line_Dn"+sell;                                                 
                   if(ObjectFind(buff_str)==-1 && Flag_Dn==true) 
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, DownBT[1], DownP[1], Time[iB_Dn], iP);
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
                        ObjectSet(buff_str, OBJPROP_COLOR, DnLineColor);                 
                        ObjectSet(buff_str, OBJPROP_WIDTH, DnLnWidth);                   
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         
                       }
//                                                       ---      
                   buff_str="LineP1_Dn"+sell;                                                 
                   if(ObjectFind(buff_str)==-1 && P1 && Flag_Dn==true) 
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, Time[iB_Dn], iP, Time[iB_Dn]-1, PP1);
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
                        ObjectSet(buff_str, OBJPROP_COLOR, Target_Color[0]);             
                        ObjectSet(buff_str, OBJPROP_WIDTH, DnLnWidth);                   
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         
                       }
                   buff_str="LineP2_Dn"+sell;                                                 
                   if(ObjectFind(buff_str)==-1 && P2 && Flag_Dn==true) 
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, Time[iB_Dn], iP, Time[iB_Dn]-1, PP2);
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
                        ObjectSet(buff_str, OBJPROP_COLOR, Target_Color[1]);             
                        ObjectSet(buff_str, OBJPROP_WIDTH, DnLnWidth);                   
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         
                       }
                   buff_str="LineP3_Dn"+sell;                                                 
                   if(ObjectFind(buff_str)==-1 && P3 && Flag_Dn==true) 
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, Time[iB_Dn], iP, Time[iB_Dn]-1, PP3);
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
                        ObjectSet(buff_str, OBJPROP_COLOR, Target_Color[2]);             
                        ObjectSet(buff_str, OBJPROP_WIDTH, DnLnWidth);                   
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         
                       }
                   buff_str="LineP4_Dn"+sell;                                                 
                   if(ObjectFind(buff_str)==-1 && P4 && Flag_Dn==true) 
                       {
                        ObjectCreate(buff_str, OBJ_TREND, 0, Time[iB_Dn], iP, Time[iB_Dn]-1, PP4);
                        ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
                        ObjectSet(buff_str, OBJPROP_COLOR, Target_Color[3]);             
                        ObjectSet(buff_str, OBJPROP_WIDTH, DnLnWidth);                   
                        ObjectSet(buff_str, OBJPROP_RAY, false);                         
                       }
//=================================================
//****  (18)        ****
//=================================================
//                   log("LineP1_Dn" + "; " + sell + "; " + DoubleToStr( Bid, Digits ) + "; " +  DnPP3);
//=================================================
//**** (19)     ****
//=================================================
                   if(MiB_Dn[1]==0 && Flag_Dn_CD_Start==false && Flag_Dn_Start==false && Flag_Up_Start==false)// (19)        
                       {
                        MiB_Dn[1]=i;                       // (19)     Dn  iB_Up[1]-, iB_Dn[0]-
                        MiP_Dn[1]=Close[i];                     // (19)    Dn  iP_Dn[1]-, iP_Dn[0]-
                        MiBT_Dn[1]=TimeCurrent();                // (19)      Dn  iBT_Dn[1]-, iBT_Dn[0]-
                        Flag_Dn_CD_Start=true;            // (19)                              
                        Flag_Dn_CD_End=false;               // (19)                              
                        Flag_Up_Start=true; // (19-7)    Up 


      AG_Message(Message, ":    Sell.");//(62)
      MN = AG_Magic_Number();          //  MagicNumber ()
                                       //   Sell:
      OrderSend( Symbol(), OP_SELL, Lot, Bid, 2, Ask+SL*Point, Ask-TP*Point, Comm, MN); 


//                        CritTrade=20;
//                        AG_Trade_Criterion_BLS();                   //     BLS
                       }
                   sell++;
                   Flag_Dn=false;                                                   //   -      
                  }
             }
        }
//
//
//
//=================================================
//****      (19-7)        ****
//=================================================
    i=0;
    if(Flag_Dn_CD_Start==true && Flag_Dn_CD_End==false)              // (19)        -                                   
//    if(Flag_Dn_Start==true)                                // (19-4)                                     
        {                                                            // (19)   ,   [0]   
         MiB_Dn[0]=i;                                                // (19)     Dn  MiB_Dn[1]-, MiB_Dn[0]-
         MiP_Dn[0]=Close[i];                                         // (19)    Up  MiP_Dn[1]-, MiP_Dn[0]-
         MiBT_Dn[0]=TimeCurrent();                         // (19-4)      

//-------(19-4)   ( )

         iBT_Dn=MiBT_Dn[0]-MiBT_Dn[1];                     // (19-4)     Up  ( )    
         days_Dn=MathFloor(MathFloor(MathFloor(iBT_Dn/60)/60)/24);                                           // (19-4)     Dn  ( )
         hours_Dn=MathFloor(MathFloor(iBT_Dn/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Dn/60)/60)/24)*24;    // (19-4)     Dn  ( )
         minutes_Dn=MathFloor(iBT_Dn/60)-MathFloor(MathFloor(iBT_Dn/60)/60)*60;                              // (19-4)     Dn  ( )
         seconds_Dn=iBT_Dn-MathFloor(iBT_Dn/60)*60;                                                          // (19-4)     Dn  ( )

//-------
         Level_TrSL=iP_Dn+TrStopLoss*Point;                          // (19)     

//-------(19-5)   ( )

//         spread = Ask - Bid                                // (19-5)    ( )
         Result=((MiP_Dn[1]-MiP_Dn[0])- spread*Point)*10000;       // (19-5)    c  ( )
         if(Result>0)
             {
              Result_P=Result;                             // (19-5)    c  ( ) P-Profit ()
              Result_L=0;
             }
         else
             {
              Result_L=Result;                             // (19-5)    c  ( ) L-Loss   ()
              Result_P=0;
             }

//-------(19-5)   Dn
         
         buff_str="Profit_Dn" + sell_CD;                               // (19-5)         
         if(ObjectFind(buff_str)==-1) 
             {
              ObjectCreate(buff_str, OBJ_TREND, 0, MiBT_Dn[1], MiP_Dn[1], MiBT_Dn[0], MiP_Dn[0]);
              ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);                 
              ObjectSet(buff_str, OBJPROP_COLOR, Violet);            // Violet         
              ObjectSet(buff_str, OBJPROP_WIDTH, 2);                   
              ObjectSet(buff_str, OBJPROP_RAY, false);                         
             }
         if(Close[i]<MiP_Dn[1] - spread*Point )                      // (19)        
             {
              ObjectMove(buff_str, 1, MiBT_Dn[0], MiP_Dn[0]);        // (19)   . 
              ObjectMove(buff_str, 0, MiBT_Dn[1], MiP_Dn[1]);        // (19)   .Deal 
              ObjectSet(buff_str, OBJPROP_COLOR, Blue);            // (19)     Violet Red        
              WindowRedraw();
             }
         else
             {
              ObjectMove(buff_str, 1, MiBT_Dn[0], MiP_Dn[0]);        // (19)   . 
              ObjectMove(buff_str, 0, MiBT_Dn[1], MiP_Dn[1]);        // (19)   .Deal 
              ObjectSet(buff_str, OBJPROP_COLOR, Red);             // (19)     Brown Blue        
              ObjectSet(buff_str, OBJPROP_WIDTH, 2);
              WindowRedraw();
             }

//-------(19-5)    Dn
//         
         if(CD_TrSL && Close[i]>iP_Dn+TrStopLoss*Point)              // (19) (TrStopLoss==TrSL)    TrStopLoss        
             {

            if (NormalizeDouble(Order[1][6],0) == 1.0)      //    Sell
               {
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);//  
               _Ord_Lots = NormalizeDouble(Order[1][5],2);  //  . 
               OrderClose(_Ord_Ticket, _Ord_Lots, Ask, 2);  //   Sell
               }

//              CritTrade=21;                               // (20-1)   SELL 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Dn  ( )
              iBT_Dn_Oll=iBT_Dn_Oll+iBT_Dn;                                                                                   // (19-5)        Dn  ( )    
              days_Dn_Oll=MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24);                                               // (19-4)      Dn  ( )
              hours_Dn_Oll=MathFloor(MathFloor(iBT_Dn_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24)*24;    // (19-4)     Dn  ( )
              minutes_Dn_Oll=MathFloor(iBT_Dn_Oll/60)-MathFloor(MathFloor(iBT_Dn_Oll/60)/60)*60;                              // (19-4)     Dn  ( )
              seconds_Dn_Oll=iBT_Dn_Oll-MathFloor(iBT_Dn_Oll/60)*60;                                                          // (19-4)    Dn  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Dn;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Dn  ( )
              Balance_Dn=Balance_Dn + Result;                        // (19-5)  Dn  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Dn_P=Result_Dn_P+Result;                             // (19-5)  Dn  c   ( ) P-Profit ()
                   Result_Dn_L=Result_Dn_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   sellP_CD++;                             // (19-9)   Dn 
                   Tr_Dn_P++;                              // (19-9)      
                  }
              else
                  {
                   Result_Dn_L=Result_Dn_L+Result;                             // (19-5)  Dn  c   ( ) L-Loss   ()
                   Result_Dn_P=Result_Dn_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   sellL_CD++;                             // (19-9)   Dn 
                   Tr_Dn_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                      // (19-9)   
              sell_CD++;                                             //   Dn 
              Tr_Dn++;                                               //   Tr Dn 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Dn[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[1], Digits )                                                 + ";" + //    

                   "Tr"                                                                             + ";" + //   (Tr) Dn 
                   TimeToStr( MiBT_Dn[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[0], Digits )                                                 + ";" + //   
                   
                   days_Dn + ";" + hours_Dn + ";" + minutes_Dn + ";" + seconds_Dn                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Dn" + ";" + sell_CD + ";" + sellP_CD + ";" + sellL_CD                           + ";" + // (19-9)   Dn , , 
                   days_Dn_Oll + ";" + hours_Dn_Oll + ";" + minutes_Dn_Oll + ";" + seconds_Dn_Oll   + ";" + // (19-5)     Dn  
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Up  ()
                   Balance_Dn + ";" + Result_Dn_P + ";" + Result_Dn_L                               + ";" + // (19-9)    Dn  ()
                   
                   Tr_Dn + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + ""                  //   Tr Dn 

                  ); */
//--------------------------------              
              Flag_Dn_CD_End=true;                                   // (19)                                         
              Flag_Dn_CD_Start=false;                                // (19)          
              Flag_Up_Start=false;    // (19-7)    Up 

             }

// 
         if(CD_CC && Close[i]>iP_Dn+PunctureCC*Point)      // (19)(Crossounter==)      ()
             {

            if (NormalizeDouble(Order[1][6],0) == 1.0)      //    Sell
               {
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);//  
               _Ord_Lots = NormalizeDouble(Order[1][5],2);  //  . 
               OrderClose(_Ord_Ticket, _Ord_Lots, Ask, 2);  //   Sell
               }

//              CritTrade=21;                               // (20-1)   SELL 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Dn  ( )
              iBT_Dn_Oll=iBT_Dn_Oll+iBT_Dn;                                                                                   // (19-5)        Dn  ( )    
              days_Dn_Oll=MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24);                                               // (19-4)      Dn  ( )
              hours_Dn_Oll=MathFloor(MathFloor(iBT_Dn_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24)*24;    // (19-4)     Dn  ( )
              minutes_Dn_Oll=MathFloor(iBT_Dn_Oll/60)-MathFloor(MathFloor(iBT_Dn_Oll/60)/60)*60;                              // (19-4)     Dn  ( )
              seconds_Dn_Oll=iBT_Dn_Oll-MathFloor(iBT_Dn_Oll/60)*60;                                                          // (19-4)    Dn  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Dn;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Dn  ( )
              Balance_Dn=Balance_Dn + Result;                        // (19-5)  Dn  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Dn_P=Result_Dn_P+Result;                             // (19-5)  Dn  c   ( ) P-Profit ()
                   Result_Dn_L=Result_Dn_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   sellP_CD++;                             // (19-9)   Dn 
                   CC_Dn_P++;                              // (19-9)      
                  }
              else
                  {
                   Result_Dn_L=Result_Dn_L+Result;                             // (19-5)  Dn  c   ( ) L-Loss   ()
                   Result_Dn_P=Result_Dn_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   sellL_CD++;                             // (19-9)   Dn 
                   CC_Dn_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                      // (19-9)   
              sell_CD++;                                             //   Dn 
              CC_Dn++;                                               //   CC_Dn 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Dn[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[1], Digits )                                                 + ";" + //    

                   "CC"                                                                             + ";" + //   (CC) Dn 
                   TimeToStr( MiBT_Dn[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[0], Digits )                                                 + ";" + //   
                   
                   days_Dn + ";" + hours_Dn + ";" + minutes_Dn + ";" + seconds_Dn                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Dn" + ";" + sell_CD + ";" + sellP_CD + ";" + sellL_CD                           + ";" + // (19-9)   Dn , , 
                   days_Dn_Oll + ";" + hours_Dn_Oll + ";" + minutes_Dn_Oll + ";" + seconds_Dn_Oll   + ";" + // (19-5)     Dn  
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Up  ()
                   Balance_Dn + ";" + Result_Dn_P + ";" + Result_Dn_L                               + ";" + // (19-9)    Dn  ()
                   
                   "" + ";" + CC_Dn + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + ""                  //   CC_Dn 

                  ); */
//--------------------------------              
              Flag_Dn_CD_End=true;                                   // (19)                                         
              Flag_Dn_CD_Start=false;                                // (19)          
              Flag_Up_Start=false;    // (19-7)    Up 

             }

//
         if(CD_PP1 && Close[i]<=PP1)                       // (19)       1
             {

            if (NormalizeDouble(Order[1][6],0) == 1.0)      //    Sell
               {
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);//  
               _Ord_Lots = NormalizeDouble(Order[1][5],2);  //  . 
               OrderClose(_Ord_Ticket, _Ord_Lots, Ask, 2);  //   Sell
               }

//              CritTrade=21;                               // (20-1)   SELL 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Dn  ( )
              iBT_Dn_Oll=iBT_Dn_Oll+iBT_Dn;                                                                                   // (19-5)        Dn  ( )    
              days_Dn_Oll=MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24);                                               // (19-4)      Dn  ( )
              hours_Dn_Oll=MathFloor(MathFloor(iBT_Dn_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24)*24;    // (19-4)     Dn  ( )
              minutes_Dn_Oll=MathFloor(iBT_Dn_Oll/60)-MathFloor(MathFloor(iBT_Dn_Oll/60)/60)*60;                              // (19-4)     Dn  ( )
              seconds_Dn_Oll=iBT_Dn_Oll-MathFloor(iBT_Dn_Oll/60)*60;                                                          // (19-4)    Dn  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Dn;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Dn  ( )
              Balance_Dn=Balance_Dn + Result;                        // (19-5)  Dn  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Dn_P=Result_Dn_P+Result;                             // (19-5)  Dn  c   ( ) P-Profit ()
                   Result_Dn_L=Result_Dn_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   sellP_CD++;                             // (19-9)   Dn 
                   P1_Dn_P++;                              // (19-9)      
                  }
              else
                  {
                   Result_Dn_L=Result_Dn_L+Result;                             // (19-5)  Dn  c   ( ) L-Loss   ()
                   Result_Dn_P=Result_Dn_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   sellL_CD++;                             // (19-9)   Dn 
                   P1_Dn_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                      // (19-9)   
              sell_CD++;                                             //   Dn 
              P1_Dn++;                                               //   P1_Dn 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Dn[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[1], Digits )                                                 + ";" + //    

                   "P1"                                                                             + ";" + //   P1_Dn 
                   TimeToStr( MiBT_Dn[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[0], Digits )                                                 + ";" + //   
                   
                   days_Dn + ";" + hours_Dn + ";" + minutes_Dn + ";" + seconds_Dn                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Dn" + ";" + sell_CD + ";" + sellP_CD + ";" + sellL_CD                           + ";" + // (19-9)   Dn , , 
                   days_Dn_Oll + ";" + hours_Dn_Oll + ";" + minutes_Dn_Oll + ";" + seconds_Dn_Oll   + ";" + // (19-5)     Dn  
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Up  ()
                   Balance_Dn + ";" + Result_Dn_P + ";" + Result_Dn_L                               + ";" + // (19-9)    Dn  ()
                   
                   "" + ";" + "" + ";" + P1_Dn + ";" + "" + ";" + "" + ";" + "" + ";" + ""                  //   P1_Dn 

                  ); */
//--------------------------------              
              Flag_Dn_CD_End=true;                                   // (19)                                         
              Flag_Dn_CD_Start=false;                                // (19)          
              Flag_Up_Start=false;    // (19-7)    Up 

             }

// 
         if(CD_PP2 && Close[i]<=PP2)                       // (19)       2
             {

            if (NormalizeDouble(Order[1][6],0) == 1.0)      //    Sell
               {
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);//  
               _Ord_Lots = NormalizeDouble(Order[1][5],2);  //  . 
               OrderClose(_Ord_Ticket, _Ord_Lots, Ask, 2);  //   Sell
               }

//              CritTrade=21;                               // (20-1)   SELL 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Dn  ( )
              iBT_Dn_Oll=iBT_Dn_Oll+iBT_Dn;                                                                                   // (19-5)        Dn  ( )    
              days_Dn_Oll=MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24);                                               // (19-4)      Dn  ( )
              hours_Dn_Oll=MathFloor(MathFloor(iBT_Dn_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24)*24;    // (19-4)     Dn  ( )
              minutes_Dn_Oll=MathFloor(iBT_Dn_Oll/60)-MathFloor(MathFloor(iBT_Dn_Oll/60)/60)*60;                              // (19-4)     Dn  ( )
              seconds_Dn_Oll=iBT_Dn_Oll-MathFloor(iBT_Dn_Oll/60)*60;                                                          // (19-4)    Dn  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Dn;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Dn  ( )
              Balance_Dn=Balance_Dn + Result;                        // (19-5)  Dn  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Dn_P=Result_Dn_P+Result;                             // (19-5)  Dn  c   ( ) P-Profit ()
                   Result_Dn_L=Result_Dn_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   sellP_CD++;                             // (19-9)   Dn 
                   P2_Dn_P++;                              // (19-9)      
                  }
              else
                  {
                   Result_Dn_L=Result_Dn_L+Result;                             // (19-5)  Dn  c   ( ) L-Loss   ()
                   Result_Dn_P=Result_Dn_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   sellL_CD++;                             // (19-9)   Dn 
                   P2_Dn_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                      // (19-9)   
              sell_CD++;                                             //   Dn 
              P2_Dn++;                                               //   P2_Dn 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Dn[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[1], Digits )                                                 + ";" + //    

                   "P2"                                                                             + ";" + //   P2_Dn 
                   TimeToStr( MiBT_Dn[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[0], Digits )                                                 + ";" + //   
                   
                   days_Dn + ";" + hours_Dn + ";" + minutes_Dn + ";" + seconds_Dn                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Dn" + ";" + sell_CD + ";" + sellP_CD + ";" + sellL_CD                           + ";" + // (19-9)   Dn , , 
                   days_Dn_Oll + ";" + hours_Dn_Oll + ";" + minutes_Dn_Oll + ";" + seconds_Dn_Oll   + ";" + // (19-5)     Dn  
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Up  ()
                   Balance_Dn + ";" + Result_Dn_P + ";" + Result_Dn_L                               + ";" + // (19-9)    Dn  ()
                   
                   "" + ";" + "" + ";" + "" + ";" + P2_Dn + ";" + "" + ";" + "" + ";" + ""                  //   P2_Dn 

                  ); */
//--------------------------------              
              Flag_Dn_CD_End=true;                                   // (19)                                         
              Flag_Dn_CD_Start=false;                                // (19)          
              Flag_Up_Start=false;    // (19-7)    Up 

             }

// 
         if(CD_PP3 && Close[i]<=PP3)                       // (19)       3
             {

            if (NormalizeDouble(Order[1][6],0) == 1.0)      //    Sell
               {
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);//  
               _Ord_Lots = NormalizeDouble(Order[1][5],2);  //  . 
               OrderClose(_Ord_Ticket, _Ord_Lots, Ask, 2);  //   Sell
               }

//              CritTrade=21;                               // (20-1)   SELL 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Dn  ( )
              iBT_Dn_Oll=iBT_Dn_Oll+iBT_Dn;                                                                                   // (19-5)        Dn  ( )    
              days_Dn_Oll=MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24);                                               // (19-4)      Dn  ( )
              hours_Dn_Oll=MathFloor(MathFloor(iBT_Dn_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24)*24;    // (19-4)     Dn  ( )
              minutes_Dn_Oll=MathFloor(iBT_Dn_Oll/60)-MathFloor(MathFloor(iBT_Dn_Oll/60)/60)*60;                              // (19-4)     Dn  ( )
              seconds_Dn_Oll=iBT_Dn_Oll-MathFloor(iBT_Dn_Oll/60)*60;                                                          // (19-4)    Dn  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Dn;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Dn  ( )
              Balance_Dn=Balance_Dn + Result;                        // (19-5)  Dn  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Dn_P=Result_Dn_P+Result;                             // (19-5)  Dn  c   ( ) P-Profit ()
                   Result_Dn_L=Result_Dn_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   sellP_CD++;                             // (19-9)   Dn 
                   P3_Dn_P++;                              // (19-9)      
                  }
              else
                  {
                   Result_Dn_L=Result_Dn_L+Result;                             // (19-5)  Dn  c   ( ) L-Loss   ()
                   Result_Dn_P=Result_Dn_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   sellL_CD++;                             // (19-9)   Dn 
                   P3_Dn_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                      // (19-9)   
              sell_CD++;                                             //   Dn 
              P3_Dn++;                                               //   P3_Dn 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Dn[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[1], Digits )                                                 + ";" + //    

                   "P3"                                                                             + ";" + //   P3_Dn 
                   TimeToStr( MiBT_Dn[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[0], Digits )                                                 + ";" + //   
                   
                   days_Dn + ";" + hours_Dn + ";" + minutes_Dn + ";" + seconds_Dn                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Dn" + ";" + sell_CD + ";" + sellP_CD + ";" + sellL_CD                           + ";" + // (19-9)   Dn , , 
                   days_Dn_Oll + ";" + hours_Dn_Oll + ";" + minutes_Dn_Oll + ";" + seconds_Dn_Oll   + ";" + // (19-5)     Dn  
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Up  ()
                   Balance_Dn + ";" + Result_Dn_P + ";" + Result_Dn_L                               + ";" + // (19-9)    Dn  ()
                   
                   "" + ";" + "" + ";" + "" + ";" + "" + ";" + P3_Dn + ";" + "" + ";" + ""                  //   P3_Dn 

                  ); */
//--------------------------------              
              Flag_Dn_CD_End=true;                                   // (19)                                         
              Flag_Dn_CD_Start=false;                                // (19)          
              Flag_Up_Start=false;    // (19-7)    Up 

             }

// 
         if(CD_PP4 && Close[i]<=PP4)                       // (19)       4
             {

            if (NormalizeDouble(Order[1][6],0) == 1.0)      //    Sell
               {
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);//  
               _Ord_Lots = NormalizeDouble(Order[1][5],2);  //  . 
               OrderClose(_Ord_Ticket, _Ord_Lots, Ask, 2);  //   Sell
               }

//              CritTrade=21;                               // (20-1)   SELL 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS


//-------------------------------(19-5)    Dn  ( )
              iBT_Dn_Oll=iBT_Dn_Oll+iBT_Dn;                                                                                   // (19-5)        Dn  ( )    
              days_Dn_Oll=MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24);                                               // (19-4)      Dn  ( )
              hours_Dn_Oll=MathFloor(MathFloor(iBT_Dn_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24)*24;    // (19-4)     Dn  ( )
              minutes_Dn_Oll=MathFloor(iBT_Dn_Oll/60)-MathFloor(MathFloor(iBT_Dn_Oll/60)/60)*60;                              // (19-4)     Dn  ( )
              seconds_Dn_Oll=iBT_Dn_Oll-MathFloor(iBT_Dn_Oll/60)*60;                                                          // (19-4)    Dn  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Dn;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Dn  ( )
              Balance_Dn=Balance_Dn + Result;                        // (19-5)  Dn  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Dn_P=Result_Dn_P+Result;                             // (19-5)  Dn  c   ( ) P-Profit ()
                   Result_Dn_L=Result_Dn_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   sellP_CD++;                             // (19-9)   Dn 
                   P4_Dn_P++;                              // (19-9)      
                  }
              else
                  {
                   Result_Dn_L=Result_Dn_L+Result;                             // (19-5)  Dn  c   ( ) L-Loss   ()
                   Result_Dn_P=Result_Dn_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   sellL_CD++;                             // (19-9)   Dn 
                   P4_Dn_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                      // (19-9)   
              sell_CD++;                                             //   Dn 
              P4_Dn++;                                               //   P4_Dn 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Dn[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[1], Digits )                                                 + ";" + //    

                   "P4"                                                                             + ";" + //   P4_Dn 
                   TimeToStr( MiBT_Dn[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[0], Digits )                                                 + ";" + //   
                   
                   days_Dn + ";" + hours_Dn + ";" + minutes_Dn + ";" + seconds_Dn                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Dn" + ";" + sell_CD + ";" + sellP_CD + ";" + sellL_CD                           + ";" + // (19-9)   Dn , , 
                   days_Dn_Oll + ";" + hours_Dn_Oll + ";" + minutes_Dn_Oll + ";" + seconds_Dn_Oll   + ";" + // (19-5)     Dn  
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Up  ()
                   Balance_Dn + ";" + Result_Dn_P + ";" + Result_Dn_L                               + ";" + // (19-9)    Dn  ()
                   
                   "" + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + P4_Dn + ";" + ""                  //   P4_Dn 

                  ); */
//--------------------------------              
              Flag_Dn_CD_End=true;                                   // (19)                                         
              Flag_Dn_CD_Start=false;                                // (19)          
              Flag_Up_Start=false;    // (19-7)    Up 

             }

// 
         if(CD_OO && (Close[i]>UpP[0]+UpV*(UpB[0]-i)+Puncture*Point)   // (19) (OpenOpposite==OO)   
                  && (High[i+1]<=UpP[0]+UpV*(UpB[0]-(i+1))))              
             {

            if (NormalizeDouble(Order[1][6],0) == 1.0)      //    Sell
               {
               _Ord_Ticket = NormalizeDouble(Order[1][4],0);//  
               _Ord_Lots = NormalizeDouble(Order[1][5],2);  //  . 
               OrderClose(_Ord_Ticket, _Ord_Lots, Ask, 2);  //   Sell
               }

//              CritTrade=21;                               // (20-1)   SELL 
//              AG_Trade_Criterion_BLS();                   // (20-1)     BLS

//-------------------------------(19-5)    Dn  ( )
              iBT_Dn_Oll=iBT_Dn_Oll+iBT_Dn;                                                                                   // (19-5)        Dn  ( )    
              days_Dn_Oll=MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24);                                               // (19-4)      Dn  ( )
              hours_Dn_Oll=MathFloor(MathFloor(iBT_Dn_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Dn_Oll/60)/60)/24)*24;    // (19-4)     Dn  ( )
              minutes_Dn_Oll=MathFloor(iBT_Dn_Oll/60)-MathFloor(MathFloor(iBT_Dn_Oll/60)/60)*60;                              // (19-4)     Dn  ( )
              seconds_Dn_Oll=iBT_Dn_Oll-MathFloor(iBT_Dn_Oll/60)*60;                                                          // (19-4)    Dn  ( )
//-------------------------------(19-5)     ( )
              iBT_Oll=iBT_Oll+iBT_Dn;                                                                                         // (19-5)          ( )
              days_Oll=MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24);                                                     // (19-5)       ( )
              hours_Oll=MathFloor(MathFloor(iBT_Oll/60)/60)-MathFloor(MathFloor(MathFloor(iBT_Oll/60)/60)/24)*24;             // (19-5)      ( )
              minutes_Oll=MathFloor(iBT_Oll/60)-MathFloor(MathFloor(iBT_Oll/60)/60)*60;                                       // (19-5)      ( )
              seconds_Oll=iBT_Oll-MathFloor(iBT_Oll/60)*60;                                                                   // (19-5)     ( )
//-------------------------------(19-5)     Dn  ( )
              Balance_Dn=Balance_Dn + Result;                        // (19-5)  Dn  c   ( )
              Balance_OLL=Balance_OLL + Result;                                  // (19-5)   c   ( )
              if(Result>0)
                  {
                   Result_Dn_P=Result_Dn_P+Result;                             // (19-5)  Dn  c   ( ) P-Profit ()
                   Result_Dn_L=Result_Dn_L;
                   Result_OLL_P=Result_OLL_P+Result;                             // (19-5)   c   ( ) P-Profit ()
                   Result_OLL_L=Result_OLL_L;
                   P_CD++;                                 // (19-9)   
                   sellP_CD++;                             // (19-9)   Dn 
                   OO_Dn_P++;                              // (19-9)      
                  }
              else
                  {
                   Result_Dn_L=Result_Dn_L+Result;                             // (19-5)  Dn  c   ( ) L-Loss   ()
                   Result_Dn_P=Result_Dn_P;
                   Result_OLL_L=Result_OLL_L+Result;                             // (19-5)   c   ( ) L-Loss   ()
                   Result_OLL_P=Result_OLL_P;
                   L_CD++;                                 // (19-9)   
                   sellL_CD++;                             // (19-9)   Dn 
                   OO_Dn_L++;                              // (19-9)      
                  }
//--------------------------------(19-5)    ( )
              _CD++;                                      // (19-9)   
              sell_CD++;                                             //   Dn 
              OO_Dn++;                                               //   OO_Dn 
/*              if(PrDeal==true)                             // (19-9)       log 
              log( Symbol()+ ";" + strPeriod( Period() )                                            + ";" + //   

                   TimeToStr( MiBT_Dn[1], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[1],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[1], Digits )                                                 + ";" + //    

                   "OO"                                                                             + ";" + //   OO_Dn 
                   TimeToStr( MiBT_Dn[0], TIME_DATE )+ ";" +  TimeToStr(MiBT_Dn[0],TIME_SECONDS)    + ";" + //      
                   DoubleToStr( MiP_Dn[0], Digits )                                                 + ";" + //   
                   
                   days_Dn + ";" + hours_Dn + ";" + minutes_Dn + ";" + seconds_Dn                   + ";" + //   
                   Result_P + ";" + Result_L                                                        + ";" + //   ()

                   _CD + ";" + P_CD + ";" + L_CD                                                   + ";" + // (19-9)   , , 
                   days_Oll + ";" + hours_Oll + ";" + minutes_Oll + ";" + seconds_Oll               + ";" + // (19-5)      
                   Balance_OLL + ";" + Result_OLL_P + ";" + Result_OLL_L                            + ";" + // (19-9)     ()
                  
                   "Dn" + ";" + sell_CD + ";" + sellP_CD + ";" + sellL_CD                           + ";" + // (19-9)   Dn , , 
                   days_Dn_Oll + ";" + hours_Dn_Oll + ";" + minutes_Dn_Oll + ";" + seconds_Dn_Oll   + ";" + // (19-5)     Dn  
                   "" + ";" + "" + ";" + ""                                                         + ";" + // (19-8)    Up  ()
                   Balance_Dn + ";" + Result_Dn_P + ";" + Result_Dn_L                               + ";" + // (19-9)    Dn  ()
                   
                   "" + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + "" + ";" + OO_Dn                  //   OO_Dn 

                  ); */
//--------------------------------              
              Flag_Dn_CD_End=true;                                   // (19)                                         
              Flag_Dn_CD_Start=false;                                // (19)          
              Flag_Up_Start=false;    // (19-7)    Up 

             }

         WindowRedraw();         
        }
//-----------------------------------------------------------
    for(i=3;i>=0;i--)                                                                    //      4-  
        {
         buff_str="Target"+i;
         if(ObjectFind(buff_str)==-1) 
             {
              ObjectCreate(buff_str, OBJ_HLINE,0, Time[0], Target[i] );                   //  , OBJ_HLINE- 
              ObjectSet(buff_str, OBJPROP_STYLE, Target_Style[i]);                        //   OBJPROP_STYLE- ,  
              ObjectSet(buff_str, OBJPROP_COLOR, Target_Color[i]);                        //   OBJPROP_COLOR-
              ObjectSet(buff_str, OBJPROP_WIDTH, Target_LW[i]);                           //   OBJPROP_WIDTH- 
             }
         else 
             {
              ObjectMove(buff_str, 0, Time[0], Target[i] );
             }
        }
//                                                 ----------      
//    string 
    buff_str="TD_LatestCulcBar";
    if(ObjectFind(buff_str)==-1)
        {
         ObjectCreate(buff_str, OBJ_ARROW,0, Time[StepBack], Low[StepBack]-2*Point );    //  , OBJ_ARROW- ()
         ObjectSet(buff_str, OBJPROP_ARROWCODE, MarkNumber);                             //     OBJ_ARROW
         ObjectSet(buff_str, OBJPROP_COLOR, MarkColor);                                  //   OBJPROP_COLOR-
        }
    else 
        {
         ObjectMove(buff_str, 0, Time[StepBack], Low[StepBack]-2*Point );
         WindowRedraw();         
        }
    if(Result>MaxProf)
         MaxProf=Result;                       // (19-9)    ( )
    if(Result<MaxLoss)
         MaxLoss=Result;                       // (19-9)     ( )


//    return(0); 
//   }
//================================================================================= 13 ==
   return(1);           //  
   }
//    14 







void Fun_New_Bar()                                                             // (18)     
   { 
    static datetime New_Time=0;
bool     New_Bar=false,                                    // (17)    
         Flag_Up=false,                                    // (17)                                        
         Flag_Dn=false;                                    // (17)      


    New_Bar=false;
    if(New_Time!=Time[0])
        {
         New_Time=Time[0];                                                     // (18)     -   
         New_Bar=true;       //           
         Flag_Up=true;                                                                   //   -    
         Flag_Dn=true;                                                                   //   -    
        }
   }
//
//
//
/*
int AG_Trade_Criterion_BLS()                   //     BLS
   { 
    if(CritTrade==10)
                        return (10);                           // ..     Buy
    if(CritTrade==20)
                        return (20);                           // ..     Sell
    if(CritTrade==11)
                        return (11);                           // ..     Buy
    if(CritTrade==21)
                        return (21);                           // ..     Sell
    return(0);                                //   
   }
*/


//
//
//
//+------------------------------------------------------------------+
/*
//+------------------------------------------------------------------+
//|                            TD_P&L_1-BLS-**.mq4 |  
//|                                 Copyright  2009, Leonid Belskiy | 
//|                                         leonid.belskiy@gmail.com |
//+------------------------------------------------------------------+ 
    26  2009                               TD_P&L_1-BLS-18.mq4   
         1.     
         2.   <log_BLS.mq4>
         3.   Qw
         4.      
         5.   for      
         6.     
         7.        (  -  )
//+------------------------------------------------------------------+ 
    4  2009                                   TD_P&L_1-BLS-18.mq4   
         1.     
         2.  
//+------------------------------------------------------------------+ 

*/
/*
         int YY=TimeYear(  Time[i]);   // Year
         int MN=TimeMonth( Time[i]);   // Month         
         int DD=TimeDay(   Time[i]);   // Day
         int HH=TimeHour(  Time[i]);   // Hour         
         int MM=TimeMinute(Time[i]);   // Minute
         int SS=TimeSeconds(Time[i]);  // Second

         int YY_1=TimeYear   (TimeCurrent());   // Year
         int MN_1=TimeMonth  (TimeCurrent());   // Month         
         int DD_1=TimeDay    (TimeCurrent());   // Day
         int HH_1=TimeHour   (TimeCurrent());   // Hour         
         int MM_1=TimeMinute (TimeCurrent());   // Minute
         int SS_1=TimeSeconds(TimeCurrent());   // Second

         int YY_0=TimeYear   (TimeCurrent());   // Year
         int MN_0=TimeMonth  (TimeCurrent());   // Month         
         int DD_0=TimeDay    (TimeCurrent());   // Day
         int HH_0=TimeHour   (TimeCurrent());   // Hour         
         int MM_0=TimeMinute (TimeCurrent());   // Minute
         int SS_0=TimeSeconds(TimeCurrent());   // Second
*/
/*
         int iBT_Up_YY=TimeYear   (iBT_Up);   // Year
         int iBT_Up_MN=TimeMonth  (iBT_Up);   // Month         
         int iBT_Up_DD=TimeDay    (iBT_Up);   // Day
         int iBT_Up_HH=TimeHour   (iBT_Up);   // Hour         
         int iBT_Up_MM=TimeMinute (iBT_Up);   // Minute
         int iBT_Up_SS=TimeSeconds(iBT_Up);   // Second
*/         

